/*Valor general, y aceptado para el clculo, de la tensin trmica.*/
#define VT 0.0252

/*Devuelve el valor alfa a partir de beta*/
float alfa (float b){
    float a;
    a=(b/(b+1));
    return a;
}

/*Devuelve el valor de la resistencia pi a partir de beta y la transconduntancia gm.*/
float r_pi (float b, float gm){
      float r;
      r=(b/gm);
      return r;
}

/*Devuelve la transconductancia gm a partir de la corriente de colector.*/
float gm (float ic){
      float gm;
      gm=(ic/VT);
      return gm;
}

/*Devuelve el valor de la resistencia e a partir de alfa y la transconductancia gm*/
float r_e (float al, float gm){
      float r;
      r=(al/gm);
      return r;
}

/*Calcula la resistencia equivalente de dos en paralelo, cuando una de ellas es cero la resultante es la otra.*/
float r_th (float r1, float r2){
      if(r1==0||r2==0){
         if(r1==0)
           return r2;
         else
           return r1;
      }
      else{
        float r;
        r=(r1*r2)/(r1+r2);
        return r;
      }
}

/*Calcula la tensin equivalente de un divisor de tensin*/
float v_th (float vbb, float r1, float r2){
      float v;
      v=vbb*(r2/(r1+r2));
      return v;
}

/*Calcula los valores de polarizacin de una etapa*/ 
typedef struct transistor{
       float beta,alfa,vbe;                         /*Datos especficos del transistor*/
       float r_load,r_s,rb1,rb2,rbth,rc,re1,re2,reeq,rpi,vcc,vee,vbb,vbth; /*Resistencias y tensiones de la polarizacin*/
       float ic,ib,ie,vb,ve,vc,vce;                 /*Datos de polarizacin*/
       float r_in,r_out,av,ai,gm,r_pi;              /*Parametros en pequea seal*/
       char estado,polari,confi;                    /*Caracteres de control*/
       transistor *anterior;                        /*Puntero al anterior*/
       transistor *siguiente;                       /*Puntero al siguiente*/
};

typedef struct transistor *etapa;

/*Funcin para polarizar el transistor, guarda los datos de polarizacin*/
int pola(etapa etp){
    char a=160;
    int ok;
    etp->vc=etp->vb=0;
    system("cls");
    printf("\n\tCONFIGURACION DE LA POLARIZACION:");
    do{printf("\n\tIntroduzca el valor de Beta: "); fflush(stdin); 
       ok=scanf("%f",&etp->beta); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    do{printf("\n\tIntroduzca el valor de Vbe, en voltios: "); fflush(stdin); 
       ok=scanf("%f",&etp->vbe); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    do{printf("\n\tIntroduzca el valor de Vcc, en voltios: "); fflush(stdin); 
       ok=scanf("%f",&etp->vcc); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    do{printf("\n\tIntroduzca el valor de Vee, en voltios: "); fflush(stdin); 
      ok=scanf("%f",&etp->vee); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    if(etp->polari=='f'||etp->polari=='F'){
      do{printf("\n\tIntroduzca el valor de Vbb, en voltios: "); fflush(stdin); 
       ok=scanf("%f",&etp->vbb); if(ok!=1) printf("Entrada no v%clida. ",a);
      } while(!ok);
    }
    if(etp->polari=='d'||etp->polari=='D'){
      do{printf("\n\tIntroduzca el valor de Rb2, en ohmios: "); fflush(stdin); 
       ok=scanf("%f",&etp->rb2); if(ok!=1) printf("Entrada no v%clida. ",a);
      } while(!ok);
    }
    do{printf("\n\tIntroduzca el valor de Rb1, en ohmios: "); fflush(stdin); 
     ok=scanf("%f",&etp->rb1); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    do{printf("\n\tIntroduzca el valor de Rc, en ohmios: "); fflush(stdin); 
       ok=scanf("%f",&etp->rc); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    if(etp->confi=='r'||etp->confi=='R'){
     do{printf("\n\tIntroduzca el valor de Re1, en ohmios: "); fflush(stdin); 
        ok=scanf("%f",&etp->re1); if(ok!=1) printf("Entrada no v%clida. ",a);
     } while(!ok);
    }
    else{
     etp->re1=0;
    }
    do{printf("\n\tIntroduzca el valor de Re2, en ohmios: "); fflush(stdin); 
       ok=scanf("%f",&etp->re2); if(ok!=1) printf("Entrada no v%clida. ",a);
    } while(!ok);
    if(etp->polari=='d'||etp->polari=='D'){
      etp->rbth=r_th(etp->rb1, etp->rb2);
      etp->vbth=v_th(etp->vcc, etp->rb1, etp->rb2);
    }
    else if(etp->polari=='f'||etp->polari=='F'){
      etp->vbth=etp->vbb;
      etp->rbth=etp->rb1;
    }
    etp->reeq=(etp->re1+etp->re2);
    etp->alfa=alfa(etp->beta);
    etp->ib=((etp->vbth-etp->vbe-etp->vee)/(etp->rbth+(etp->beta+1)*etp->reeq));
    etp->ic=(etp->ib*etp->beta);
    etp->ie=(etp->ib+etp->ic);
    etp->ve=((etp->ie*etp->reeq)+etp->vee);
    etp->vb=(etp->ve+etp->vbe);
    etp->vc=(etp->vcc-(etp->ic*etp->rc));
    etp->vce=(etp->vc-etp->ve);
    etp->gm=gm(etp->ic);
    etp->r_pi=r_pi(etp->beta,etp->gm);
    if(etp->vc>etp->vb)
      etp->estado='a';
    else
      etp->estado='n';
}

/*Funcin para guardar las impedancias del diseo*/
int  impedancias(etapa etp){
     if(etp->confi=='e'||etp->confi=='E'){       
       etp->r_in=r_th(etp->rbth,etp->r_pi);
       etp->r_out=etp->rc;
     }
     if(etp->confi=='c'||etp->confi=='C'){
       etp->r_in=r_th(etp->rbth,(etp->r_pi+(etp->beta+1)*(r_th(etp->reeq,etp->r_load))));
       etp->r_out=r_th(etp->reeq,((etp->r_pi+(r_th(etp->r_s,etp->rbth)))/(1+etp->beta)));
     }
     if(etp->confi=='r'||etp->confi=='R'){
       etp->r_in=r_th(etp->rbth,(etp->r_pi+(1+etp->beta)*etp->re1));
       etp->r_out=etp->rc;
     }
     if(etp->confi=='b'||etp->confi=='B'){
       etp->r_in=r_th(etp->reeq,(etp->r_pi)/(1+etp->beta));
       etp->r_out=etp->rc;
     }
     return 0;
}

/*Funcin para guardar las impedancias del diseo*/
int ganancias(etapa etp){
    if(etp->confi=='e'||etp->confi=='E'){ 
      etp->av=((-etp->gm)*(r_th(etp->r_out,etp->r_load)) *
               (etp->r_in/(etp->r_s+etp->r_in)));
      etp->ai=((-etp->gm)*(r_th(etp->rbth,etp->r_pi)) *
              ((etp->r_out)/(etp->r_out+etp->r_load)));
    }
    if(etp->confi=='c'||etp->confi=='C'){
      etp->av=((etp->r_in)/(etp->r_s+etp->r_in))*(((1+etp->beta)*(r_th(etp->reeq,etp->r_load)))/(etp->r_pi+(1+etp->beta)*(r_th(etp->reeq,etp->r_load))));
      etp->ai=(etp->av)*((etp->r_s+etp->r_in)/etp->r_load);
    }
    if(etp->confi=='r'||etp->confi=='R'){
      etp->av=((etp->r_in)/(etp->r_s+etp->r_in))*((-etp->beta*(r_th(etp->r_out,etp->r_load)))/(etp->r_pi+(1+etp->beta)*etp->re1));
      etp->ai=((-etp->beta*etp->rbth)/(etp->rbth+etp->r_pi+(1+etp->beta)*etp->re1))*((etp->r_out)/(etp->r_out+etp->r_load));
    }
    if(etp->confi=='b'||etp->confi=='B'){
      etp->av=((etp->r_in)/(etp->r_s+etp->r_in))*etp->gm*r_th(etp->rc,etp->r_load);
      etp->ai=etp->gm*etp->r_in*((etp->r_out)/(etp->r_out+etp->r_load));
    }
    return 0;
}

/*Imprime por pantalla el punto de trabajo de un transistor*/
int pntotrabaj(etapa etp,int t){
    char o=162;
    printf("\n\n\tPUNTO DE TRABAJO DEL TRANSISTOR %d:",t);
    printf("\n\n\t  Corriente Ic = %f Amperios;",etp->ic);
    printf("\n\t  Tensi%cn Vce = %f Voltios;",o,etp->vce);
    printf("\n\n\tPARAMETROS EN PEQUE%cA SE%cAL DEL TRANSISTOR %d:",164,164,t);
    printf("\n\n\t  Gm = %f A/V;",etp->gm);
    printf("\n\t  Rpi = %f Ohmios;",etp->r_pi);
    printf("\n\t");
    return 0;
}

/*Imprime por pantalla las impedancias y ganancias de un transistor*/
int ganimp(etapa etp,int t){
    char o=162;
    printf("\n\n\tGANANCIAS E IMPEDANCIAS DEL TRANSISTOR %d:",t);
    printf("\n\n\t  Ganancia de tensi%cn Av = %f V/V;",o,etp->av);
    printf("\n\n\t  Ganancia de corriente Ai = %f A/A;",etp->ai);
    printf("\n\n\t  Impedancia de entrada Zin = %f Ohmios;",etp->r_in);
    printf("\n\n\t  Impedancia de salida Zout = %f Ohmios;",etp->r_out);
    printf("\n\t");
    return 0;
}
